#ifndef EFL_UI_SELECTABLE_EO_HH
#define EFL_UI_SELECTABLE_EO_HH
#include <Eo.h>

extern "C" {
#include "efl_object.eo.h"
#include "efl_ui_selectable.eo.h"
}
#include <Eina.hh>
#include <Eo.hh>
#include "efl_object.eo.hh"
#ifndef EFL_UI_SELECTABLE_FWD_GUARD
#define EFL_UI_SELECTABLE_FWD_GUARD
namespace efl { namespace ui { 
struct Selectable;
} } 
namespace efl { namespace eo { template<> struct is_eolian_object< ::efl::ui::Selectable> : ::std::true_type {}; } }
namespace efl { namespace eo { template<> struct is_eolian_object< ::efl::ui::Selectable&> : ::std::true_type {}; } }
namespace efl { namespace eo { template<> struct is_eolian_object< ::efl::ui::Selectable const> : ::std::true_type {}; } }
namespace efl { namespace eo { template<> struct is_eolian_object< ::efl::ui::Selectable const&> : ::std::true_type {}; } }
#endif
#ifndef EFL_OBJECT_FWD_GUARD
#define EFL_OBJECT_FWD_GUARD
namespace efl { 
struct Object;
} 
namespace efl { namespace eo { template<> struct is_eolian_object< ::efl::Object> : ::std::true_type {}; } }
namespace efl { namespace eo { template<> struct is_eolian_object< ::efl::Object&> : ::std::true_type {}; } }
namespace efl { namespace eo { template<> struct is_eolian_object< ::efl::Object const> : ::std::true_type {}; } }
namespace efl { namespace eo { template<> struct is_eolian_object< ::efl::Object const&> : ::std::true_type {}; } }
#endif

namespace eo_cxx {
namespace efl { namespace ui { 
struct Selectable {
    static Efl_Class const* _eo_class()
    {
        return EFL_UI_SELECTABLE_INTERFACE;
    }
    Eo* _eo_ptr() const { return *(reinterpret_cast<Eo **>(const_cast<Selectable *>(this))); }
    operator ::efl::ui::Selectable() const;
    operator ::efl::ui::Selectable&();
    operator ::efl::ui::Selectable const&() const;
    /// @cond LOCAL
     ::efl::eolian::address_of_operator<Selectable> operator&() { return {this}; }
     ::efl::eolian::address_of_operator<Selectable const > operator&() const { return {this}; }
    /// @endcond
};
} } 
}
namespace efl { namespace ui { 
struct Selectable : private ::efl::eo::concrete
{
    explicit Selectable( ::Eo* eo)
        : ::efl::eo::concrete(eo) {}
    Selectable(std::nullptr_t)
        : ::efl::eo::concrete(nullptr) {}
    explicit Selectable() = default;
    Selectable(Selectable const&) = default;
    Selectable(Selectable&&) = default;
    Selectable& operator=(Selectable const&) = default;
    Selectable& operator=(Selectable&&) = default;
    template <typename Derived>
    Selectable(Derived&& derived
        , typename std::enable_if<
            ::efl::eo::is_eolian_object<Derived>::value
             && std::is_base_of< Selectable, Derived>::value>::type* = 0)
            : ::efl::eo::concrete(derived._eo_ptr()) {}

    static Efl_Class const* _eo_class()
    {
        return EFL_UI_SELECTABLE_INTERFACE;
    }
    Eo* _eo_ptr() const { return *(reinterpret_cast<Eo **>(const_cast<Selectable *>(this))); }
    static struct item_selected_event
    {
        static Efl_Event_Description const* description()
        { return EFL_UI_EVENT_ITEM_SELECTED; }
        typedef  ::efl::Object parameter_type;
    } const item_selected_event;
#ifdef EFL_CXXPERIMENTAL
    template <typename F>
    typename std::enable_if<std::is_bind_expression<F>::value, ::efl::eolian::signal_connection>::type
    item_selected_event_cb_add(F function)
    {
        return ::efl::eolian::event_add(item_selected_event, *this, function);
    }
    template <typename F>
    typename std::enable_if<!std::is_bind_expression<F>::value, ::efl::eolian::signal_connection>::type
    item_selected_event_cb_add(F function)
    {
        return ::efl::eolian::event_add(item_selected_event, *this, std::bind(function));
    }
#endif
    static struct item_unselected_event
    {
        static Efl_Event_Description const* description()
        { return EFL_UI_EVENT_ITEM_UNSELECTED; }
        typedef  ::efl::Object parameter_type;
    } const item_unselected_event;
#ifdef EFL_CXXPERIMENTAL
    template <typename F>
    typename std::enable_if<std::is_bind_expression<F>::value, ::efl::eolian::signal_connection>::type
    item_unselected_event_cb_add(F function)
    {
        return ::efl::eolian::event_add(item_unselected_event, *this, function);
    }
    template <typename F>
    typename std::enable_if<!std::is_bind_expression<F>::value, ::efl::eolian::signal_connection>::type
    item_unselected_event_cb_add(F function)
    {
        return ::efl::eolian::event_add(item_unselected_event, *this, std::bind(function));
    }
#endif
    static struct selection_paste_event
    {
        static Efl_Event_Description const* description()
        { return EFL_UI_EVENT_SELECTION_PASTE; }
        typedef void parameter_type;
    } const selection_paste_event;
#ifdef EFL_CXXPERIMENTAL
    template <typename F>
    typename std::enable_if<std::is_bind_expression<F>::value, ::efl::eolian::signal_connection>::type
    selection_paste_event_cb_add(F function)
    {
        return ::efl::eolian::event_add(selection_paste_event, *this, function);
    }
    template <typename F>
    typename std::enable_if<!std::is_bind_expression<F>::value, ::efl::eolian::signal_connection>::type
    selection_paste_event_cb_add(F function)
    {
        return ::efl::eolian::event_add(selection_paste_event, *this, std::bind(function));
    }
#endif
    static struct selection_copy_event
    {
        static Efl_Event_Description const* description()
        { return EFL_UI_EVENT_SELECTION_COPY; }
        typedef void parameter_type;
    } const selection_copy_event;
#ifdef EFL_CXXPERIMENTAL
    template <typename F>
    typename std::enable_if<std::is_bind_expression<F>::value, ::efl::eolian::signal_connection>::type
    selection_copy_event_cb_add(F function)
    {
        return ::efl::eolian::event_add(selection_copy_event, *this, function);
    }
    template <typename F>
    typename std::enable_if<!std::is_bind_expression<F>::value, ::efl::eolian::signal_connection>::type
    selection_copy_event_cb_add(F function)
    {
        return ::efl::eolian::event_add(selection_copy_event, *this, std::bind(function));
    }
#endif
    static struct selection_cut_event
    {
        static Efl_Event_Description const* description()
        { return EFL_UI_EVENT_SELECTION_CUT; }
        typedef void parameter_type;
    } const selection_cut_event;
#ifdef EFL_CXXPERIMENTAL
    template <typename F>
    typename std::enable_if<std::is_bind_expression<F>::value, ::efl::eolian::signal_connection>::type
    selection_cut_event_cb_add(F function)
    {
        return ::efl::eolian::event_add(selection_cut_event, *this, function);
    }
    template <typename F>
    typename std::enable_if<!std::is_bind_expression<F>::value, ::efl::eolian::signal_connection>::type
    selection_cut_event_cb_add(F function)
    {
        return ::efl::eolian::event_add(selection_cut_event, *this, std::bind(function));
    }
#endif
    static struct selection_start_event
    {
        static Efl_Event_Description const* description()
        { return EFL_UI_EVENT_SELECTION_START; }
        typedef void parameter_type;
    } const selection_start_event;
#ifdef EFL_CXXPERIMENTAL
    template <typename F>
    typename std::enable_if<std::is_bind_expression<F>::value, ::efl::eolian::signal_connection>::type
    selection_start_event_cb_add(F function)
    {
        return ::efl::eolian::event_add(selection_start_event, *this, function);
    }
    template <typename F>
    typename std::enable_if<!std::is_bind_expression<F>::value, ::efl::eolian::signal_connection>::type
    selection_start_event_cb_add(F function)
    {
        return ::efl::eolian::event_add(selection_start_event, *this, std::bind(function));
    }
#endif
    static struct selection_changed_event
    {
        static Efl_Event_Description const* description()
        { return EFL_UI_EVENT_SELECTION_CHANGED; }
        typedef void parameter_type;
    } const selection_changed_event;
#ifdef EFL_CXXPERIMENTAL
    template <typename F>
    typename std::enable_if<std::is_bind_expression<F>::value, ::efl::eolian::signal_connection>::type
    selection_changed_event_cb_add(F function)
    {
        return ::efl::eolian::event_add(selection_changed_event, *this, function);
    }
    template <typename F>
    typename std::enable_if<!std::is_bind_expression<F>::value, ::efl::eolian::signal_connection>::type
    selection_changed_event_cb_add(F function)
    {
        return ::efl::eolian::event_add(selection_changed_event, *this, std::bind(function));
    }
#endif
    static struct selection_cleared_event
    {
        static Efl_Event_Description const* description()
        { return EFL_UI_EVENT_SELECTION_CLEARED; }
        typedef void parameter_type;
    } const selection_cleared_event;
#ifdef EFL_CXXPERIMENTAL
    template <typename F>
    typename std::enable_if<std::is_bind_expression<F>::value, ::efl::eolian::signal_connection>::type
    selection_cleared_event_cb_add(F function)
    {
        return ::efl::eolian::event_add(selection_cleared_event, *this, function);
    }
    template <typename F>
    typename std::enable_if<!std::is_bind_expression<F>::value, ::efl::eolian::signal_connection>::type
    selection_cleared_event_cb_add(F function)
    {
        return ::efl::eolian::event_add(selection_cleared_event, *this, std::bind(function));
    }
#endif
    /// @cond LOCAL
     ::efl::eolian::address_of_operator<Selectable> operator&() { return {this}; }
     ::efl::eolian::address_of_operator<Selectable const > operator&() const { return {this}; }
    /// @endcond
    ::efl::eo::wref<Selectable> _get_wref() const { return ::efl::eo::wref<Selectable>(*this); }
    ::efl::eo::concrete const& _get_concrete() const { return *this; }
    ::efl::eo::concrete& _get_concrete() { return *this; }
    using ::efl::eo::concrete::_eo_ptr;
    using ::efl::eo::concrete::_release;
    using ::efl::eo::concrete::_reset;
    using ::efl::eo::concrete::_delete;
    using ::efl::eo::concrete::operator bool;
#ifdef EFL_CXXPERIMENTAL
    const Selectable* operator->() const { return this; }
    Selectable* operator->() { return this; }
    operator Eo*() const { return _eo_ptr(); }
#endif 
    friend bool operator==(Selectable const& lhs, Selectable const& rhs)
    { return lhs._get_concrete() == rhs._get_concrete(); }
    friend bool operator!=(Selectable const& lhs, Selectable const& rhs)
    { return !(lhs == rhs); }
};
static_assert(sizeof(Selectable) == sizeof(Eo*), "");
static_assert(std::is_standard_layout<Selectable>::value, "");
} } 
#endif
